
  # create the saving folder if necessary
  WatersDataConvert<-function(peaklistDataFolder="./",convertedDataFolder="./Converted?",nLineSkip=10, isNOsampleNO=1)
  {
    if ( ! file.exists(dataSaveFolder) )
    {
       dir.create(convertedDataFolder,showWarnings=FALSE, recursive=TRUE)
    }

    # list all csv file
    csvfiles<-list.files(path=peaklistDataFolder,pattern="(.TXT)$");
    for ( nf in 1:length(csvfiles) ) {
        # read data from each csv file
        oriCSVfile<-csvfiles[nf]
        csvName<-strsplit(basename(oriCSVfile),'\\.')[[1]][1]
        saveCSVfile<-paste(convertedDataFolder,"forIsoMS_",csvName,".csv",sep='')
      
        print("",quote = FALSE);
        print(paste(oriCSVfile, "was read at:", format(Sys.time(),"%Y-%B-%d %H:%M:%S")),quote = FALSE)

        # load all data as lines
        fnameCurrent<-paste(peaklistDataFolder,oriCSVfile,sep='')
        allLines<-readLines(fnameCurrent)
        nLine<-length(allLines)
        indFUN<-grep("^FUNCTION",allLines)  # location of FUN

        # extract FUNCTION 1 
        allLines<-allLines[indFUN[1]:(indFUN[2]-1)]
        allLines<-sub("^FUNCTION",-1,allLines);
        allLines<-sub("^Scan",-2,allLines);
        allLines<-sub("^Retention Time",-3,allLines);
        allLines<-sub("\t"," ",allLines)

        # tricky to write to file and reload [faster than read directly]
        write.table(allLines,file="convertWatersData.tmp",col.names=FALSE,row.name=FALSE,quote=FALSE)
        subDB<-read.table(file="convertWatersData.tmp",blank.lines.skip=TRUE)
        file.remove("convertWatersData.tmp")
 
        indScan<-which(subDB[,1]==-2)
        nScan<-length(indScan)
        nRow<-nrow(subDB)
        numPeak<-nRow-2*nScan-1

        #create the export matrix
        pkmat<-matrix(nrow=numPeak, ncol=5)
        colnames(pkmat)<-c("sample","No","rt","mz", "maxo")

        np0<-1
        ind0 <-4
        for (ns in 1:nScan)
        {
           ScanNoc<-subDB[ind0-2,2]
           RTc<-subDB[ind0-1,2]
           if (ns==nScan)
           {
             ind1<-nRow
           } else {
             ind1<-indScan[ns+1]-1
           }
           numSC<-ind1-ind0+1
           np1<-np0+numSC-1
           pkmat[np0:np1,2]<-ScanNoc
           pkmat[np0:np1,3]<-RTc*60
           pkmat[np0:np1,4]<-subDB[ind0:ind1,1]
           pkmat[np0:np1,5]<-subDB[ind0:ind1,2]
           np0<-np1+1
           ind0<-ind1+3
        }
        pkmat[,1] <- 1
        # export the matrix
        print("",quote = FALSE)
        print(paste(oriCSVfile, " was converted at:", format(Sys.time(),"%Y-%B-%d %H:%M:%S")),quote = FALSE)
        pirnt("",quote = FALSE)
        write.table(pkmat,file=saveCSVfile,col.names=TRUE,row.name=FALSE,quote=FALSE,sep=",")
    }   
        print("",quote = FALSE)
        print("Waters data format conversion was done",quote = FALSE)
        print("",quote = FALSE)
  }
